/*
Code written by: Dean Lunz (aka Crated by: X)
Web: http://www.createdbyx.com/ 
 */
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace GunsABlazin
{
    public class Bullet : ICloneable
    {
        private FrameSequence bulletSequence;
        private float speed;
        private Vector2 position;
        private float power;
        private float dir;
        private float maxDistance = float.MaxValue;
        private float dist = 0;


        public void ResetDistanceTraveled()
        {
            dist = 0;
        }

        public float DistanceTraveled
        {
            get { return dist; }
        }
        
        public float MaxDistance
        {
            get { return maxDistance; }
            set { maxDistance = value; }
        }
	
        public float Direction
        {
            get { return dir; }
            set { dir = value; }
        }  	

        public float Power
        {
            get { return power; }
            set { power = value; }
        }

        public bool IsMaxDistanceReached
        {
            get { return (dist >= maxDistance); }
        }

        public void SetPosition(Vector2 p, bool calcDistance)
        {
            if (dist >= maxDistance) return; 
            if (calcDistance == true)
            {
                float d = Vector2.Distance(position, p);
                dist += d;
            }
            position = p;
        }

        public Vector2 Position
        {
            get { return position; }
            set {
                if (dist >= maxDistance) return;
                float d = Vector2.Distance(position, value);
                dist += d;
                position = value; 
            }
        }

        public float Speed
        {
            get { return speed; }
            set { speed = value; }
        }

        public FrameSequence BulletSequence
        {
            get { return bulletSequence; }
            set { bulletSequence = value; }
        }

        #region ICloneable Members

        public virtual object Clone()
        {
            Bullet tmp = new Bullet();
            tmp.BulletSequence = this.BulletSequence;
            tmp.Direction = this.Direction;
            tmp.Position = this.Position;
            tmp.Power = this.Power;
            tmp.Speed = this.Speed;
            tmp.maxDistance = this.maxDistance;
            return tmp;
        }

        #endregion
    }
}
