/*
Code written by: Dean Lunz (aka Crated by: X)
Web: http://www.createdbyx.com/ 
Original source for this code comes from http://www.ziggyware.com/
 */
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace GunsABlazin
{
    public class FPSCounter : GameComponent
    {
        float fps = 0;
        float totalTime = 0;
        float frames = 0;

        public float FPS
        {
            get { return fps; }
        }

        public float Frames
        {
            get { return frames; }
        }

        public float TotalTime
        {
            get { return totalTime; }
        }

        public FPSCounter(Game game)
            : base(game)
        {
        }

        public void Reset()
        {
            fps = 0;
            totalTime = 0;
            frames = 0;
        }

        public override void Initialize()
        {
            base.Initialize();
        }

        public override void Update(GameTime gameTime)
        {
            totalTime += (float)gameTime.ElapsedRealTime.TotalSeconds;
            frames++;


            if (totalTime >= 1.0f)
            {
                totalTime = totalTime - (float)((int)totalTime);

                fps = frames;

                frames = 0;

              //  System.Diagnostics.Debug.WriteLine("FPS: " + fps.ToString());
            }

            base.Update(gameTime);
        }
    }
}
