/*
Code written by: Dean Lunz (aka Crated by: X)
Web: http://www.createdbyx.com/ 
 */
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace GunsABlazin
{
    public class Player
    {
        private Actor act;
        private PlayerIndex gpad = PlayerIndex.One;
        private int currentWeapon = -1;
        private Vector2 bulletSpawnOffset;
        private Collections.WeaponList weapons = new Collections.WeaponList();
        private int prevWeapon = -1;
        private Vector2 target;
	
        public Vector2 Target
        {
            get { return target; }
            set { target = value; }
        }
	
        public Weapon NextWeapon()
        {
            if (weapons.Count == 0) return null;
            currentWeapon++;
            if (currentWeapon > weapons.Count - 1) currentWeapon = 0;
            return weapons[currentWeapon];
        }

        public Weapon PrevWeapon()
        {
            if (weapons.Count == 0) return null;
            currentWeapon--;
            if (currentWeapon < 0) currentWeapon = weapons.Count - 1;
            return weapons[currentWeapon];
        }

        public Weapon GetCurrentWeapon()
        {
            if (currentWeapon == -1) return null;
            return weapons[currentWeapon];
        }

        public Collections.WeaponList Weapons
        {
            get { return weapons; }
        }

        public Vector2 BulletSpawnOffsett
        {
            get { return bulletSpawnOffset; }
            set { bulletSpawnOffset = value; }
        }

        public int CurrentWeapon
        {
            get { return currentWeapon; }
            set
            {
                if (weapons.Count == 0) return;
                if (value < 0) throw new IndexOutOfRangeException();
                if (value > weapons.Count - 1) throw new IndexOutOfRangeException();
                currentWeapon = value;
            }
        }

        public PlayerIndex GamePad
        {
            get { return gpad; }
            set { gpad = value; }
        }

        public Actor Actor
        {
            get { return act; }
            set { act = value; }
        }
    }
}
