/*
Code written by: Dean Lunz (aka Crated by: X)
Web: http://www.createdbyx.com/ 
 */
#region Using Statements
using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
#endregion

namespace GunsABlazin
{
    public class Weapon
    {
        private string bullet = string.Empty;
        private TimeSpan shootDelay;
        private BulletManager bm;
        private TimeSpan lastShootTime;
        private Texture2D targetTexture = null;

        public Bullet GetBulletReference()
        {
            if (this.bullet == string.Empty) return null;
            return bm.BulletReferences[this.bullet];
        }

        public Texture2D TargetTexture
        {
            get { return targetTexture; }
            set { targetTexture = value; }
        }

        public Weapon(BulletManager b)
        {
            this.bm = b;
        }

        public BulletManager Bulletmanager
        {
            get { return bm; }
            set
            {
                if (value == null) throw new ArgumentNullException("value");
                bm = value;
            }
        }

        public void Shoot(GameTime gameTime, Vector2 pos, float dir)
        {
            if (gameTime.TotalGameTime.Ticks > (lastShootTime.Ticks + shootDelay.Ticks))
            {
                Bullet b = (Bullet)bm.BulletReferences[this.bullet].Clone();
                b.SetPosition(pos, false);
                b.Direction = dir + MathHelper.ToRadians(-90);                
                bm.Bullets.Add(b);
                lastShootTime = gameTime.TotalGameTime;
            }
        }

        public TimeSpan ShootDelay
        {
            get { return shootDelay; }
            set { shootDelay = value; }
        }

        public virtual string Bullet
        {
            get { return bullet; }
            set { bullet = value; }
        }

        public virtual string Name
        {
            get { return string.Empty; }
        }

        public virtual string Description
        {
            get { return string.Empty; }
        }

    }
}
